"use strict";

var _require = require('../utils'),
    isReactComponent = _require.isReactComponent,
    importSpecifier = _require.importSpecifier,
    expr2str = _require.expr2str,
    ClassNames = _require.ClassNames,
    LibraryClassNames = _require.LibraryClassNames;

var options = require('../options');

module.exports = function (_ref) {
  var t = _ref.types,
      template = _ref.template;
  var CLASSNAMES = ClassNames;
  var classAttrs = options.classAttrs;

  function JSXAttributeVisitor(path) {
    if (!classAttrs.includes(path.node.name.name) || !t.isJSXExpressionContainer(path.node.value) || t.isCallExpression(path.node.value.expression) && expr2str(path.node.value.expression.callee) === CLASSNAMES) return;

    if (!this.libraryVarSpecifier) {
      this.libraryVarSpecifier = importSpecifier(path, "".concat(CLASSNAMES, ",default"), LibraryClassNames);
    }

    path.node.value.expression = template('$RCS($EXPR$)')({
      $RCS: this.libraryVarSpecifier.local.name,
      $EXPR$: path.node.value.expression
    }).expression;
  }

  return {
    visitor: {
      Program: {
        enter: function enter(path) {
          if (!isReactComponent(path)) return;
          var ctx = {
            libraryVarSpecifier: null
          };
          path.traverse({
            JSXAttribute: JSXAttributeVisitor
          }, ctx);
        }
      }
    }
  };
};